7
Optim Lett DOI 10.1007/s11590-013-0637-2 ORIGINAL PAPER Approximation algorithms for k-partitioning problems with partition matroid constraint Weidong Li · Jianping Li Received: 5 November 2011 / Accepted: 26 March 2013 © Springer-Verlag Berlin Heidelberg 2013 Abstract The k -partitioning problem with partition matroid constraint is to partition the union of k given sets of size m into m sets such that each set contains exactly one element from each given set. With the objective of minimizing the maximum load, we present an efficient polynomial time approximation scheme (EPTAS) for the case where k is a constant and a full polynomial time approximation scheme (FPTAS) for the case where m is a constant; with the objective of maximizing the minimum load, we present a 1 k 1 -approximation algorithm for the general case, an EPTAS for the case where k is a constant; with the objective of minimizing the l p -norm of the load vector, we prove that the layered LPT algorithm (Wu and Yao in Theor Comput Sci 374:41–48, 2007) is an all-norm 2-approximation algorithm. Keywords Partition matroid · Approximation algorithm · EPTAS · FPTAS 1 Introduction The k -partitioning problem with partition matroid constraint [12], also called uniform k -partition problem [7], is defined as follows. We are given k sets R 1 , R 2 ,..., R k with each set R j ={r 1 j , r 2 j ,..., r mj } containing m nonnegative real numbers. Let E =∪ k j =1 R j . For any subset S E , let w( S) = r ij S r ij be the load of S. A feasible solution is a partition ( S 1 , S 2 ,..., S m ) of E such that | S i R j |= 1, for i = 1, 2,..., m W. Li (B ) Department of Atmospheric Science, Yunnan University, 650091 Kunming, People’s Republic of China e-mail: [email protected]; [email protected] J. Li Department of Mathematics, Yunnan University, 650091 Kunming, People’s Republic of China e-mail: [email protected] 123

Approximation algorithms for $k$-partitioning problems with partition matroid constraint

Embed Size (px)

Citation preview

Page 1: Approximation algorithms for $k$-partitioning problems with partition matroid constraint

Optim LettDOI 10.1007/s11590-013-0637-2

ORIGINAL PAPER

Approximation algorithms for k-partitioning problemswith partition matroid constraint

Weidong Li · Jianping Li

Received: 5 November 2011 / Accepted: 26 March 2013© Springer-Verlag Berlin Heidelberg 2013

Abstract The k-partitioning problem with partition matroid constraint is to partitionthe union of k given sets of size m into m sets such that each set contains exactly oneelement from each given set. With the objective of minimizing the maximum load,we present an efficient polynomial time approximation scheme (EPTAS) for the casewhere k is a constant and a full polynomial time approximation scheme (FPTAS) forthe case where m is a constant; with the objective of maximizing the minimum load,we present a 1

k−1 -approximation algorithm for the general case, an EPTAS for thecase where k is a constant; with the objective of minimizing the l p-norm of the loadvector, we prove that the layered LPT algorithm (Wu and Yao in Theor Comput Sci374:41–48, 2007) is an all-norm 2-approximation algorithm.

Keywords Partition matroid · Approximation algorithm · EPTAS · FPTAS

1 Introduction

The k-partitioning problem with partition matroid constraint [12], also called uniformk-partition problem [7], is defined as follows. We are given k sets R1, R2, . . . , Rk

with each set R j = {r1 j , r2 j , . . . , rmj } containing m nonnegative real numbers. LetE = ∪k

j=1 R j . For any subset S ⊆ E , letw(S) = ∑ri j ∈S ri j be the load of S. A feasible

solution is a partition (S1, S2, . . . , Sm) of E such that |Si ∩R j | = 1, for i = 1, 2, . . . ,m

W. Li (B)Department of Atmospheric Science, Yunnan University, 650091 Kunming,People’s Republic of Chinae-mail: [email protected]; [email protected]

J. LiDepartment of Mathematics, Yunnan University, 650091 Kunming,People’s Republic of Chinae-mail: [email protected]

123

Page 2: Approximation algorithms for $k$-partitioning problems with partition matroid constraint

W. Li, J. Li

and j = 1, 2, . . . , k. The objective is to make the loads w(S1), w(S2), · · · , w(Sm) asnearly equal as possible. Generally, there are three ways to achieve this objective:

(1) minimizing the maximum load of the subsets, called the min–max problem;(2) maximizing the minimum load of the subsets, called the max–min problem;

(3) minimizing the l p-norm of the load vector, i.e., min[∑mi=1w

p(Si )]1p , called the

min-l p problem.

For a minimization (or maximization) problem, an algorithm is called ar -approximation algorithm if it can produce a feasible solution with the objectivevalue at most (or at least) r O PT , where O PT denotes the optimal value. A polyno-mial time approximation scheme (PTAS, for short) is a family of (1+ε)-approximationalgorithms, where ε ∈ (0, 1). An efficient PTAS (EPTAS) is a special PTAS whoserunning time is O( f (1/ε)|I |c), where c is a constant independent of 1/ε and |I | isthe length of the instance. A full polynomial time approximation scheme (FPTAS) isa special EPTAS whose running time is polynomial in 1/ε.

Wu and Yao [12] showed that the layered LPT algorithm has a tight worst-case ratioof 2 − 1/m for the min–max problem, and has a worst-case ratio of 1/m for the max–min problem. They [13] also showed that the modified LPT algorithm has a worst-caseratio of 5

2 for the min–max problem. A closely related problem is the k partition prob-lem. Babel et al. [1] designed a 4

3 -approximation algorithm for the k partition problemunder the min–max objective. He et al. [8] designed a max{2/k, 1/m}-approximationalgorithm for the k partition problem under the max–min objective. More detailedresults can be found in [1–10].

This paper is divided into the following sections. In Sect. 2, we present an EPTASfor the case where k is a constant, and a FPTAS for the case where m is a constant forthe min–max problem. In Sect. 3, we present a 1/(k −1)-approximation algorithm forthe general case, and an EPTAS for the case where k is a constant for the max–minproblem. In Sect. 4, we prove that the layered LPT algorithm in [12] is an all-norm2-approximation algorithm for the min-l p problem.

2 The min–max problem

2.1 k is a constant

We will study the case where k is a constant. Implementing the layered LPTalgorithm in [12], we obtain a feasible solution with objective value L satisfyingL/2 ≤ O PT ≤ L . Without loss of generality, by dividing all the elements by L , wehave 1/2 ≤ O PT ≤ 1.

For any given constant ε > 0 (assume that 1/ε is an integer), construct an instanceE = ∪k

j=1 R j , where R j = {r1 j , . . . , rm j } and ri j = � ri jε

2k� ε

2k , for j = 1, 2, . . . , k and

i = 1, 2, . . . ,m.

Lemma 1 The optimal value ˆO PT of instance E satisfies ˆO PT ≤ O PT + ε2 ≤ 1+ ε

2 .

Proof Let (S∗1 , S∗

2 , . . . , S∗m) be an optimal solution for instance E . Consider a fea-

sible solution (S1, S2, . . . , Sm) for instance E , where Si = {ri j |ri j ∈ S∗i }. Clearly,

123

Page 3: Approximation algorithms for $k$-partitioning problems with partition matroid constraint

Approximation algorithms for k-partitioning problems

w(Si ) = ∑ri j ∈Si

ri j = ∑ri j ∈Si

� ri jε

2k� ε

2k ≤ ∑ri j ∈S∗

iri j + ε

2 ≤ O PT + ε2 ≤ 1 + ε

2 ,

where the first inequality follows from the fact |S∗i | = |Si | = k, and the last inequality

follows from that O PT ≤ 1. �Lemma 2 The optimal solution for instance E can be found within O(m).

Proof For i = 0, 1, . . . , 2kε

and j = 1, 2, . . . , k, let n ji denote the number of elements

iε2k in R j . We call C ⊆ E a feasible configuration, if C satisfiesw(C) = ∑

ri j ∈C ri j ≤1 + ε

2 , and |C ∩ R j | = 1 for j = 1, 2, . . . , k. Let C be the set of all feasible configu-

rations. Note that all the elements in instance E are integer multiples of ε2k . Thus, we

have |C| ≤ ( 2kε

+ 1)k = O(1), as k and 1ε

are constants. For any C ∈ C, let n(i, j,C)

be the frequency of element iε2k in C ∩ R j . Clearly, n(i, j,C) ∈ {0, 1}. For any solution

(S1, S2, . . . , Sm) for instance E , let xC = |{Si |Si = C, i = 1, 2, . . . ,m}|. It is easy toverify that the min–max problem for instance E is equivalent to the following integerlinear programming (ILP) formulation.

min z∑

C∈CxC = m;

C∈Cn(i, j,C)xC = n j

i , i = 0, 1, . . . ,2k

ε, j = 1, 2, . . . , k;

w(C)yC ≤ z,∀C ∈ C;yC ≤ xC ≤ myC ,∀C ∈ C;xC ∈ {0, 1, . . . ,m}, yC ∈ {0, 1}

As the numbers of constraints and variables are constants, the optimal solution(xC , yC ) for the above ILP can be found within O(m) by using Lenstra’s algorithm[11]. Finally, we can construct an optimal solution (S1, S2, . . . , Sm) for instance Ecorresponding to (xC , yC ). �Theorem 3 When k is a constant, the min–max problem possesses an EPTAS.

Proof For an instance E , construct a corresponding instance E , and then find an opti-mal solution (S1, S2, . . . , Sm) for E as in the proof of Lemma 2. Consider the feasiblesolution (S1, S2, . . . , Sm), where Si = {ri j |ri j ∈ Si }. Clearly, w(Si ) = ∑

ri j ∈Siri j ≤

∑ri j ∈Si

ri j ≤ ˆO PT ≤ O PT + ε2 ≤ (1 + ε)O PT , where the last inequality follows

from the fact 1/2 ≤ O PT . From Lemma 2, the running time is polynomial in m,which implies that the min–max problem possesses an EPTAS when k is a constant.

2.2 m is a constant

Let T = ∑mi=1

∑kj=1 ri j denote the sum of elements in E . Clearly, O PT ≥ T/m.

When m is a constant, our algorithm is described as follows.

123

Page 4: Approximation algorithms for $k$-partitioning problems with partition matroid constraint

W. Li, J. Li

Approximation Algorithm for fixed m:

Step 1 Construct an instance E = ∪kj=1 R j , where R j = {r1 j , r2 j , · · · , rm j } and

ri j = � ri jεTkm

� εTkm , for j = 1, 2, . . . , k and i = 1, 2, . . . ,m.

Step 2 Setψ0 = {(0, 0, . . . , 0)}. For j = 1, 2, . . . , k, letψ j denote the set of all pos-sible load vectors obtained by partitioning the first j sets R1, R2, · · · , R j .Compute ψ j = ψ j−1 + φ j , where φ j denotes the set of all possible enumer-ation vectors of the elements in R j .

Step 3 Find the optimal vector inψk . Then, construct its corresponding optimal solu-tion (S1, . . . , Sm). Finally, output the feasible solution (S1, S2, . . . , Sm) forE , where Si = {ri j |ri j ∈ Si }.

Theorem 4 When m is a constant, the Approximation Algorithm for fixed mis a FPTAS for the min–max problem.

Proof From the definition of ri j , we have ˆO PT ≤ O PT . Thus, w(Si ) =∑

ri j ∈Siri j ≤ ∑

ri j ∈Si(ri j + εT

km ) ≤ ˆO PT + k · εTkm ≤ O PT + εT

m ≤ (1 + ε)O PT ,where the last inequality follows from that O PT ≥ T/m.

Step 1 can be done within O(km); Step 2 can be done within O(k( kmε

+ 1)m ·m!), because φ j contains at most m! vectors and ψ j contains at most ( km

ε+ 1)m

vectors; Step 3 can be done within O(( kmε

+ 1)m). Hence, the overall running time ofApproximation Algorithm for fixed m is O(k( km

ε+ 1)m · m! + km), i.e., it is

a FPTAS for the min–max problem. �

3 The max–min problem

3.1 The general case

The greedy- type algorithm for the max–min problem is described as follows. Findthe maximum element r (m)i j in E (m) = E , put r (m)i j and the smallest elements in R(m)j ′

into Sm for each j ′ �= j , and then set E (m−1) = ∪kj=1 R(m−1)

j , where R(m−1)j is the set

of the remaining elements in R j . Next, find the maximum element r (m−1)i j in E (m−1),

put r (m−1)i j and the smallest elements in R(m−1)

j ′ into Sm−1 for each j ′ �= j , and set

E (m−2) = ∪kj=1 R(m−2)

j , where R(m−2)j is the set of the remaining elements in R j . Do

this until that there are no remaining elements.

Theorem 5 The approximation ratio of the greedy- type algorithm is 1k−1 , and this

ratio is tight.

Proof For τ = 1, 2, . . . ,m, let O PT (E (τ )) be the optimal value of instance E (τ ) =∪k

j=1 R(τ )j . Clearly, w(S1) ≥ O PT (E (1)) ≥ O PT (E (1))k−1 . For each integer τ > 1,

assume that the maximum element r (τ )i j in E (τ ) belongs to R(τ )j . For any j ′ �= j , wehave

123

Page 5: Approximation algorithms for $k$-partitioning problems with partition matroid constraint

Approximation algorithms for k-partitioning problems

w(Sτ ) ≥ r (τ )i j + min R(τ )j ′ ≥∑

t �= j ′ max R(τ )t

k − 1+ min R(τ )j ′

≥∑

t �= j ′ max R(τ )t + min R(τ )j ′

k − 1≥ O PT (E (τ ))

k − 1(1)

For each integer τ > 1, consider an optimal partition (S∗1 , S∗

2 , . . . , S∗τ ) for instance

E (τ ). Without loss of generality, assume that r (τ )i j ∈ S∗τ . Interchange the elements in

∪τj=1S∗j such that S∗

τ contains r (τ )i j and the smallest element in R(τ )j ′ for each j ′ �= j . Thiswill not decrease the loads of the first τ −1 subsets. Thus, the first τ −1 new subsets isa feasible solution for instance E (τ−1), which implies O PT (E (τ−1)) ≥ O PT (E (τ )).

Using (1), for τ = 1, 2, . . . ,m, we have

w(Sτ ) ≥ O PT (E (τ ))

k − 1≥ O PT (E (τ+1))

k − 1≥ · · · ≥ O PT (E (m))

k − 1= O PT

k − 1,

which implies that the approximation ratio of the greedy- type algorithm is 1k−1 .

We present an example to show that the ratio is tight. Consider the instance E =∪k

j=1 R j , where m = k and R j = {1, 1, . . . , 1, 0} for j = 1, 2, . . . , k. Clearly, theoutput value of the greedy- type algorithm is 1. However, O PT = k −1. Therefore,the approximation ratio is tight. �

3.2 k is a constant

Using the 1k−1 -approximation algorithm in Sect. 3.1, we obtain a feasible solution with

objective value L , where L ≤ O PT ≤ (k − 1)L ≤ kL . If the element ri j satisfiesthat ri j ≥ kL ≥ O PT , there is an optimal solution (S∗

1 , S∗2 , . . . , S∗

m) satisfying that,there exists an index i such that S∗

i = {ri j } ∪ j ′ �= j {Rminj ′ }, where Rmin

j ′ denotes the

smallest element in R j ′ . If not, assume ri j ∈ S∗i . By interchanging S∗

i ∩ R j ′ and Rminj ′

for each j ′ �= j , we obtain a new optimal solution satisfying S∗i = {ri j }∪ j ′ �= j {Rmin

j ′ }.By deleting the elements in {ri j } ∪ j ′ �= j {Rmin

j ′ }, we obtain a small instance withoutchanging the optimal value. Therefore, we can assume that all elements in E are nomore than kL . For any feasible solution (S1, S2, . . . , Sm) for instance E , we havemaxi w(Si ) ≤ k2L , as |Si | = k.

For any given constant ε ∈ (0, 1) (assuming 1ε

is an integer), construct an instance

E = ∪kj=1 R j , where R j = {r1 j , · · · , rm j } and ri j = � ri j

εLk

� εLk for j = 1, 2, . . . , k and

i = 1, 2, . . . ,m.

Lemma 6 The optimal value ˆO PT for instance E satisfies ˆO PT ≥ O PT − εL.

Proof Let (S∗1 , S∗

2 , . . . , S∗m) be the optimal solution for instance E . Consider a fea-

sible solution (S1, S2, . . . , Sm) for E , where Si = {ri j |ri j ∈ S∗i }. Clearly, w(Si ) =

∑ri j ∈Si

� ri jεLk

� εLk ≥ ∑

ri j ∈S∗i

ri j − k · εLk ≥ O PT − εL . �

123

Page 6: Approximation algorithms for $k$-partitioning problems with partition matroid constraint

W. Li, J. Li

By using a similar method to that in the proof of Lemma 2, we obtain an optimalsolution (S1, S2, . . . , Sm) for E . Consider the feasible solution (S1, S2, . . . , Sm) forE , where Si = {ri j |ri j ∈ Si }. Clearly, w(Si ) ≥ ∑

ri j ∈Siri j ≥ ˆO PT ≥ O PT − εL ≥

(1 − ε)O PT , where the second inequality follows from the definition of ˆO PT , thethird inequality follows from Lemma 6, and the last inequality follows from the factL ≤ O PT . Hence,

Theorem 7 When k is a constant, the max–min problem possesses an EPTAS.

Using a similar method to the Approximation Algorithm for fixed m in Sect.2.2, we obtain

Theorem 8 When m is a constant, the max–min problem possesses a FPTAS.

4 The min-l p problem

Let A =∑m

i=1∑k

j=1 ri j

m denote the average load of the m subsets. From the convexity

of f (t) = t p, we have O PT ≥ m1p A. Wu and Yao [12] presented the following

Layered LPT algorithm: (1) sort the elements in R j in non-increasing order, i.e.,r1 j ≥ r2 j ≥ · · · ≥ rmj , and set Si = {ri1} for i = 1, 2, . . . ,m; (2) for j = 2, 3, . . . , kand i = 1, 2, . . . ,m, allocate the element ri j ∈ R j to the i th least loaded subset;(3) Output (S1, S2, . . . , Sm).

Lemma 9 [12] In the solution (S1, S2, . . . , Sm), if w(Si1) ≥ w(Si2), then w(Si1) ≤w(Si2)+ max Si1 , where max Si1 is the maximum element in Si1 .

Theorem 10 The Layered LPT algorithm is an all-norm 2-approximation algo-rithm for the min-l p problem.

Proof Clearly, there exists an index τ satisfyingw(Sτ ) ≤ A. From Lemma 9, we havew(Si )− max Si ≤ w(Sτ ) ≤ A. Thus, for any p ≥ 1, we have

‖(l1, . . . , lm)‖p = ‖(w(S1)− max S1, . . . , w(Sm)− max Sm)+ (max S1, . . . ,max Sm)‖p

≤ ‖(w(S1)− max S1, . . . , w(Sm)− max Sm)‖p + ‖(max S1, . . . ,max Sm)‖p

≤ ‖(A, . . . , A)‖p + O PT = m1p A + O PT ≤ 2O PT .

�Using a similar method to the Approximation Algorithm for fixed m in

Sect. 2.2, we obtain

Theorem 11 When m is a constant, the min-l p problem possesses a FPTAS.

Acknowledgments The authors are grateful to the two anonymous referees whose comments and sug-gestions have led to a substantially improved presentation for the paper. The work is supported by theTianyuan Fund for Mathematics of the National Natural Science Foundation of China [No. 11126315] andthe National Natural Science Foundation of China [No. 61063011].

123

Page 7: Approximation algorithms for $k$-partitioning problems with partition matroid constraint

Approximation algorithms for k-partitioning problems

References

1. Babel, L., Kellerer, H., Kotov, V.: The k-partitioning problem. Math. Methods Oper. Res. 47, 59–82(1998)

2. Bruglieri, M., Ehrgott, M., Hamacher, H.W., Maffioli, F.: An annotated bibliography of combinatorialoptimization problems with fixed cardinality constraints. Discrete Appl. Math. 154, 1344–1357 (2006)

3. Chen, S., He, Y., Lin, G.: 3-partitioning for maximizing the minimum load. J. Comb. Optim. 6, 67–80(2002)

4. Dell’Amico, M., Iori, M., Martello, S.: Heuristic algorithms and scatter search for the cardinalityconstrained P||Cmax problem. J. Heuristics 10, 169–204 (2004)

5. Dell’Amico, M., Iori, M., Martello, S., Monaci, M.: Lower bound and heuristic algorithms for theki partitioning problem. Eur. J. Oper. Res. 171, 725–742 (2006)

6. Dell’Amico, M., Martello, S.: Bounds for the cardinality constrained P||Cmax problem. J. Sched.4, 123–138 (2001)

7. Dell’ Olmo, P., Hansen, P., Pallottino, S., Storchi, G.: On uniform k-partition problems. Discrete Appl.Math. 150, 121–139 (2005)

8. He, Y., Tan, Z., Zhu, J., Yao, E.: k-Partitioning problems for maximizing the minimum load. Comput.Math. Appl. 46, 1671–1681 (2003)

9. Kellerer, H., Kotov, V.: A 76 -approximation algorithm for 3-partitioning and its application to multi-

processor scheduling. INFOR 37, 48–56 (1999)10. Kellerer, H., Woeginger, G.: A tight bound for 3-partitioning. Discrete Appl. Math. 45, 249–259 (1993)11. Lenstra, H.W.: Integer programming with a fixed number of variables. Math. Oper. Res. 8, 538–548

(1983)12. Wu, B., Yao, E.: k-Partitioning problems with partition matroid constraint. Theor. Comput. Sci. 374,

41–48 (2007)13. Wu, B., Yao, E.: Lower bounds and modified LPT algorithm for k-partitioning problems with partition

matroid constraint. Appl. Math. J. Chin. Univ. 23, 1–8 (2008)

123